#include "ti-85.h"
#include "summit.h"

.org $8BF9			;8BF9, duh! (If you don't know why, you need
				;to learn a little more about TASM)  This
				;must be patched in at 8BF9, or it won't work
				;the simplest way is just to store this in to
                                ;the current shell on the home screen (Must be
                                ;compiled WITHOUT a header, cause the header
                                ;is already there.
.db     $00,$53,$01,$41,$00,$07
Point2Start:                    ;8BFF (address in mem)
        jp Start

MenuTitle:                      ;8C02
.db     "Summit",0

ZShell40:			;8C09 needed for ZShell 4.0 compatibility
	jp ROM_CALLER		;ROM_CALL(index)
	jp NZ,Return		;CALL_Z(addr)
	jp CALLER		;CALL_(addr)
	jp Z,Return		;CALL_NZ(addr)
	jp CALLER
	jp NC,Return		;CALL_C(addr)
	jp CALLER
	jp C,Return		;CALL_NC(addr)
	jp CALLER
	jp NZ,Return		;JUMP_Z(addr)
	jp JUMPER		;JUMP_(addr)
	jp Z,Return		;JUMP_NZ(addr)
	jp JUMPER
	jp NC,Return		;JUMP_C(addr)
	jp JUMPER
	jp C,Return		;JUMP_NC(addr)
	jp JUMPER

Program_Address:	;8C3C
.dw     $0000		;PROGRAM_ADDR

RomVersionByte:		;8C3E
.db     $00		;ROM_VERS

SummitVersion:          ;8C3F
.db     $04             ;$04 is a BCD 0.4

ZShellBits:		;8C40	(ZS_BITS)
.db     $00             ;warpout (for menus)

ROM_TABLE:              ;8C41
.db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

MenuName:               ;8C9B
.db     5,"AUTOR"            ;Name Length of 5, Auto Run string

Routines:
        jp Execute      ;8CA1   (EXE)
        jp SetDefaults  ;8CA4   (SET_DEF)
        jp ExeAtHL      ;8CA7   (EXE_HL)
        jp Fill8        ;8CAA   (FILL8)
        jp ExitBreak    ;8CAD   (EXIT_BREAK)
        jp ExitFromShell;8CB0   (EXIT_SHELL)

OrgSP:                  ;8CB3
.dw     0

MoreRoutines:
        jp Pause        ;8CB5   (G_PAUSE)
        jp WaitKey      ;8CB8   (G_WAIT)
        jp Fill16       ;8CBB   (FILL16)
        jp Clear16      ;8CBE   (CLEAR16)
        jp Clear8       ;8CC1   (CLEAR8)
        jp IntInstall   ;8CC4   (INT_INS)
        jp IntRemove    ;8CC7   (INT_REMOVE)
        jp HLMenuDeci   ;8CCA   (DM_HL_DECI)
        jp ShutDown     ;8CCD   (SHUT_DOWN)
        jp CheckVAT     ;8CD0   (VAT_CHECK)
        jp NewVAR       ;8CD3   (NEW_VAR)
        jp DelVAR       ;8CD6   (DEL_VAR)
;Not coded yet:
        jp ResizeVAR    ;8CD9   (RESIZE_VAR)
        jp RelocateVAR  ;8CDC   (RELO_VAR)
;Coded:
        jp TSRInstall   ;8CDF   (TSR_INSTALL)
        jp TSRRemove    ;8CE2   (TSR_REMOVE)
        jp CleanInt     ;8CE5   (CLEAN_INT)

Clear8:                         ;8CE8
        xor A

Fill8:                          ;8CE9, Fill B bytes at HL with A
	ld (HL),A
	inc HL
        djnz Fill8
	ret

Clear16:                        ;8CEE
        ld (HL),0

Fill16:
        ld E,L
        ld D,H
        inc DE
        dec BC
        ldir
        ret

Pause:                          ;8CF7, Waits for any key press
        call GET_KEY
        or A
        jr Z,Pause
        ret

Filler:                         ;8CFE, Filler.  DO NOT USE!
.db     0,0

IntTable:                       ;8D00
.dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

Filler2:                        ;8E00
.dw     0,0,0,0,0,0,0,0,0,0

Filler3:
.dw     0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0
.dw     0,0,0,0,0,0,0,0,0,0

CurrentProg:                    ;8E64
.dw     0,0,0,0,0

TempOP1:                        ;8E6E
.dw     0,0,0,0,0

VATCheckedName:                 ;8E78
.dw     0,0,0,0,0

TSRName:                        ;8E82
.dw     0,0,0,0,0

IntLocation:                    ;8E8C
.dw     0                       ;Only 1 interrupt


InterruptStart:                 ;8E8E
        ex AF,AF'
        exx

        in A,(3)
        bit 1,A                 ;Make sure LCD is on
        jr Z,InterruptEnd

        ld HL,OP1
        ld DE,TempOP1
        ld BC,10
        ldir
        
        call IGuts

        ld DE,OP1
        ld HL,TempOP1
        ld BC,10
        ldir

InterruptEnd:
        exx
        ex AF,AF'
        jp $38

CleanInt:
        xor A
        ld (TSRName),A
        ld L,A
        ld H,A
        ld (IntLocation),HL
        ret

IntInstall:
        im 1
        ld (IntLocation),HL
        jr IntSetup

IntRemove:
        ld HL,0
        ld (IntLocation),HL
        ld A,(TSRName)
        or A
        ret NZ
        im 1
        ret

TSRRemove:
        xor A
        ld (TSRName),A
        ld HL,(IntLocation)

        ld D,A
        ld E,A

        call CP_HL_DE
        ret NZ

        im 1
        ret

TSRInstall:
        im 1
        ld DE,TSRName
        ld BC,10
        ldir

IntSetup:
        ld A,$8D
        ld I,A

        inc A

FixInt:
        ld B,0
        ld HL,$8D00
        call Fill8
        im 2
        ret

ResizeVAR:

VARLocation     =TEXT_MEM
VAR_VAT         =TEXT_MEM+2
CopyLen         =TEXT_MEM+4

DelVAR:
        LD_OP1_HL
        SEARCH_VAT
        ret C
        JDELETE_VAR

NewVAR:
        push BC
        LD_OP1_HL
        pop BC

        inc BC
        inc BC

        push BC
        ALLOCATE
        pop BC

        dec BC
        dec BC

        ex DE,HL
        ld (HL),C
        inc HL
        ld (HL),B
        ret

CheckVAT:
        ld (Compare1+1),A

CheckVAT1:
        ld DE,(VAT_END)

        call CP_HL_DE

        jr Z,None

Compare1:
        ld A,$FF
        cp (HL)
        jr Z,FoundOne             ;fix

        dec HL
        dec HL
        dec HL

        ld E,(HL)
        ld D,0

        scf
        ccf

        sbc HL,DE
        dec HL
        jr CheckVAT1

None:
        scf
        ret

FoundOne:
        dec HL
        ld E,(HL)
        dec HL
        ld D,(HL)
        dec HL

        push DE
        ld B,(HL)
        ld DE,VC_NAME
        ld A,B
        ld (DE),A

VATCopy:
        dec HL
        inc DE

        ld A,(HL)
        ld (DE),A

        djnz VATCopy

        dec HL
        pop DE

        scf
        ccf
        ret

ShutDown:
        ld A,1
        out (3),A
        xor A
        out (4),A
        halt
        ld A,$16
        out (4),A
        rra
        out (3),A
        ret

HLMenuDeci:
        ld de,TEXT_MEM+5
        xor A
        ld (DE),A
        ld B,5

ConvLoop:
        dec DE
        call UNPACK_HL
        add A,'0'
        ld (DE),A
        djnz ConvLoop

        ex DE,HL
        push HL

        ld B,4

DeciFixLoop:
        ld A,'0'
        cp (HL)
        jr NZ,DoneDisplay
        ld (HL),$20
        inc HL
        djnz DeciFixLoop

DoneDisplay:
        pop HL
        JD_ZM_STR

IGuts:
        ld HL,TSRName
        ld A,(HL)
        or A
        jr Z,SkipTSR

        dec HL

        LD_OP1_HL
        SEARCH_VAT
        jr C,KillTSR

        ex DE,HL

        inc HL
        inc HL

        push HL
        call LD_HL_MHL
        ld DE,$5404
        call CP_HL_DE
        pop HL

        jr NZ,KillTSR

        inc HL
        inc HL
        inc HL

        ld DE,(PROGRAM_ADDR)
        push DE

        ld (PROGRAM_ADDR),HL
        xor A                   ;looking for the zero at end of description
        ld BC,90                ;90 bytes is longer than any description I've
        cpir                    ;ever seen
        ld (CallDude+1),HL      ;execute from the byte after description

CallDude:
        call $FFFF
        pop HL
        ld (PROGRAM_ADDR),HL

        jr SkipTSR

KillTSR:
        xor A
        ld (TSRName),A

SkipTSR:
        ld HL,(IntLocation)
        ld DE,0
        call CP_HL_DE
        jr Z,CheckTSR

        jp (HL)

CheckTSR:
        ld A,(TSRName)
        or A
        ret NZ
        im 1
        ret

WaitKey:                        ;Waits for a key of your choice
        ld (Compare+1),A

WaitLoop:
        call GET_KEY

Compare:
        cp $FF                  ;$FF gets overwritten
        jr NZ,WaitLoop
        ret

Start:
        ld A,7
        out (5),A
        ld A,($7FFF)
        ld (ROM_VERS),A

	ld HL,($800C)		;normal cursor position
	push HL

        ld (ORIGINAL_SP),SP
	
	call SetDefaults

        ld HL,ROM_DATA
        ld DE,ROM_TABLE
        call PatchROM

        cp 'P'
        jr NZ,ExitBreak

CopyName:
        ld HL,(CURR_INPUT)

	LD_OP1_HL

	ld HL,OP1
	ld A,(HL)		;get length byte of data in OP1

	or A			;zero length?
	jr Z,RunMenu		;run menu if so

	inc HL
	ld (HL),A		;put length in right place
	
	call Execute

ExitFromShell:
	set 1,(IY+13)
        ZCLEARTEXT              ;fill TEXT_MEM with spaces so we don't fill
				;the screen with garbage on exit

ExitBreak:
	call SetDefaults	;return with correct printing parameters

        ld SP,(ORIGINAL_SP)

	pop HL
	ld ($800C),HL		;restore cursor

	jp HOME_SCREEN		;jump to home screen (displays contents of
				;text memory as ascii)

RunMenu:
        ld HL,MenuName-1
	LD_OP1_HL
	call Execute
	jr ExitFromShell

Return:				
	ex (SP),HL
	inc HL
	inc HL
	ex (SP),HL
	ret

SetDefaults:			;sets all the defaults
	xor A			;A=0
	ld ($834B),A		;set printing parameters
	ld ($8353),A

	ld HL,$0000		;set printing parameters
	ld ($800C),HL		;Cursor position
	ld ($8334),HL		;Menu cursor position

	APD_OFF			;turn off APD
	ret

Execute:			;ZShell files only right now
	SEARCH_VAT
	ret C

	inc DE			;point it at the ZShell header, so we can
	inc DE			;check it
	ex DE,HL		;exchange, so we can use (HL)

        push HL

        call LD_HL_MHL
        ld DE,$FD00
        call CP_HL_DE
        jr Z,ZSFile

        ld DE,$4E04
        call CP_HL_DE
        jr Z,ZSFile

        ld DE,$5404
        call CP_HL_DE
        ret NZ

        pop DE

        ld HL,OP1+1

        jp TSRInstall

ZSFile:
        pop HL
        inc HL
        inc HL
	inc HL			;HL -> description data of file

ExeAtHL:
	ld DE,(PROGRAM_ADDR)	;can be run recursively (A program runs
	push DE			;another program)

	ld (PROGRAM_ADDR),HL	;set PROGRAM_ADDR, so programs will work

Execution:
        xor A                   ;looking for the zero at end of description
        ld BC,90                ;90 bytes is longer than any description I've
        cpir                    ;ever seen
        ld (CallMan+1),HL       ;execute from the byte after description

	ld HL,TEXT_MEM		;zero the text memory, like in ZShell
	ld B,168		;length of the text mem

        call Clear8
	call SetDefaults

        ZBUSY_OFF               ;turn off busy indicator

CallMan:
	call $FFFF		;will return to caller after program runs
	pop HL
	ld (PROGRAM_ADDR),HL
	ret

ROM_CALLER:			;196/191 clock cycles, without hldata
	ld (HLDATA+1),HL	;save for later

	pop HL			;get pointer for ret
	inc HL			;point it past the data byte of ROM_CALL()
	push HL			;put it back
	dec HL

	push AF			;save flags for later
	push DE
	ld E,(HL)		;get ROM_CALL number in E
	bit 7,E			;test if its FIND_PIXEL
	jr Z,NotFP		;if not, jr to NotFP
	ld E,$0E		;if so, make it $0E (FIND_PIXEL's actual
				;offset in memory)

NotFP:
	ld HL,ROM_TABLE		;HL -> ROM table
	ld A,E
	add A,A
	add A,E			;A=E*3
	ld E,A			;DE=offset of ROM call
	ld D,0
	add HL,DE		;HL -> address word for ROM call in table

	ld (CHANGER_JUMP+1),HL	;fix jp at end of routine to point to ROM
				;jump table


FixUp:
	pop DE
	pop AF			;it is here, instead of before, to ensure
				;that the flags are the same as before

HLDATA:				;20 clock cycles including changer jump
	ld HL,$FFFF		;the FF's will be overwritten EVERY time

CHANGER_JUMP:
	jp $FFFF		;the FF's will be overwritten EVERY time
 
CALLER:
	ld (HLDATA+1),HL	;save for later
	pop HL			;get pointer for ret
	inc HL			;point it past the data word of call
	inc HL
	push HL			;put it back
	dec HL
	dec HL

Common2Jump:
	push AF
	push DE
	
	ld E,(HL)		;get offset of call
	inc HL
	ld D,(HL)

	ld HL,(PROGRAM_ADDR)
	add HL,DE		;get actual address of subroutine

	ld (CHANGER_JUMP+1),HL	;change the jump pointer
	jr FixUp

JUMPER:
	ld (HLDATA+1),HL	;save for later
	pop HL			;get pointer for ret

	jr Common2Jump

;input: DE-> destination address
;       HL-> patch data
;Return:DE-> byte after last patch
;       HL-> byte after last piece of patched data
;       A='I' if incompatible ROM version
;       A='P' if successful patch
PatchROM:
        push DE                 ;save destination address

        ld A,(ROM_VERS)         ;MUST be ZShell 4.0 compatible shell
	ld C,A

	ld E,0

CheckROM:
	cp $35
	jr Z,Found

	inc E
	cp $91
	jr Z,Found

	inc E
	cp $97
	jr Z,Found

	inc E
	cp $3D
	jr Z,Found

	cp $8E
	jr Z,Found

        cp $5E
        jr Z,Found

	inc E
	cp $57
	jr Z,Found

Error3:			;error if no correct ROM version
        ld A,'I'
        ret

Found:
	ld B,(HL)
	inc HL

	push BC

        xor A

        sla E

MulEB:
	add A,E
	djnz MulEB

Silly:
	ld C,A

	ld B,0

	add HL,BC

	pop BC

        pop DE

LoadPatches:
	ld A,$C3
	ld (DE),A
	inc DE			;load jump byte

	ld A,(HL)
	ld (DE),A
	inc HL
	inc DE			;low byte

	ld A,(HL)
	ld (DE),A
	inc HL
	inc DE			;high byte

	djnz LoadPatches

        ld A,'P'
        ret

ROM_DATA:
.db     30

Rom10:
.dw     $3FE0   ;TX_CHARPUT
.dw     $3B78   ;D_LT_STR
.dw     $3BB4   ;M_CHARPUT
.dw     $3BBA   ;D_ZM_STR
.dw     $3BFC   ;D_LM_STR
.dw     $3C92   ;GET_T_CUR
.dw     $3D82   ;SCROLL_UP
.dw     $3DE8   ;TR_CHARPUT
.dw     $3DEE   ;CLEARLCD
.dw     $3DF4   ;D_HL_DECI
.dw     $3E54   ;CLEARTEXT
.dw     $3E60   ;D_ZT_STR
.dw     $3E96   ;BUSY_OFF
.dw     $3EAE   ;BUSY_ON
.dw     $6B6D   ;FIND_PIXEL
.dw     $21D2   ;ZB_BYTES
.dw     $261B   ;MUL_HL
.dw	$297C	;ALLOCATE
.dw	$2C25	;DELETE_VAR
.dw     $2C0F   ;REMOVE_DE
.dw     $2DC2   ;VPOP_A
.dw     $2DB1   ;VPUSH_A
.dw     $3C7A   ;GRAPH2LCD
.dw     $3DA0   ;D_MENU
.dw     $3D7C   ;SAVE_TEXT
.dw     $3BC6   ;SAVE_TEXM
.dw     $3DA6   ;CLR_WINDOW
.dw     $3DDC   ;CLR_LINE
.dw     $3E66   ;C2TOP
.dw     $3EA2   ;KEY_HANDLER

Rom9:
.dw     $3FC5   ;TX_CHARPUT
.dw     $3B5D   ;D_LT_STR
.dw     $3B99   ;M_CHARPUT
.dw     $3B9F   ;D_ZM_STR
.dw     $3BE1   ;D_LM_STR
.dw     $3C77   ;GET_T_CUR
.dw     $3D67   ;SCROLL_UP
.dw     $3DCD   ;TR_CHARPUT
.dw     $3DD3   ;CLEARLCD
.dw     $3DD9   ;D_HL_DECI
.dw     $3E39   ;CLEARTEXT
.dw     $3E45   ;D_ZT_STR
.dw     $3E7B   ;BUSY_OFF
.dw     $3E93   ;BUSY_ON
.dw     $6B6D   ;FIND_PIXEL
.dw     $21B8   ;ZB_BYTES
.dw     $2601   ;MUL_HL
.dw	$2962	;ALLOCATE
.dw	$2C0B	;DELETE_VAR
.dw     $2BF5   ;REMOVE_DE
.dw     $2DA8   ;VPOP_A
.dw     $2D97   ;VPUSH_A
.dw     $3C5F   ;GRAPH2LCD
.dw     $3D85   ;D_MENU
.dw     $3D61   ;SAVE_TEXT
.dw     $3BAB   ;SAVE_TEXM
.dw     $3D8B   ;CLR_WINDOW
.dw     $3DC1   ;CLR_LINE
.dw     $3E4B   ;C2TOP
.dw     $3E87   ;KEY_HANDLER

Rom8:
.dw     $3FF5   ;TX_CHARPUT
.dw     $3BA5   ;D_LT_STR
.dw     $3BE1   ;M_CHARPUT
.dw     $3BE7   ;D_ZM_STR
.dw     $3C29   ;D_LM_STR
.dw     $3CA7   ;GET_T_CUR
.dw     $3D97   ;SCROLL_UP
.dw     $3DFD   ;TR_CHARPUT
.dw     $3E03   ;CLEARLCD
.dw     $3E09   ;D_HL_DECI
.dw     $3E63   ;CLEARTEXT
.dw     $3E6F   ;D_ZT_STR
.dw     $3EAB   ;BUSY_OFF
.dw     $3EC3   ;BUSY_ON
.dw     $6C9A   ;FIND_PIXEL
.dw     $220D   ;ZB_BYTES
.dw     $2656   ;MUL_HL
.dw	$29B7	;ALLOCATE
.dw	$2C60	;DELETE_VAR
.dw     $2C4A   ;REMOVE_DE
.dw     $2DFD   ;VPOP_A
.dw     $2DEC   ;VPUSH_A
.dw     $3C8F   ;GRAPH2LCD
.dw     $3DB5   ;D_MENU
.dw     $3D91   ;SAVE_TEXT
.dw     $3BED   ;SAVE_TEXM
.dw     $3DBB   ;CLR_WINDOW
.dw     $3DF1   ;CLR_LINE
.dw     $3E75   ;C2TOP
.dw     $3EB7   ;KEY_HANDLER

Rom456:
.dw     $3FF1   ;TX_CHARPUT
.dw     $3BA1   ;D_LT_STR
.dw     $3BDD   ;M_CHARPUT
.dw     $3BE3   ;D_ZM_STR
.dw     $3C25   ;D_LM_STR
.dw     $3CA3   ;GET_T_CUR
.dw     $3D93   ;SCROLL_UP
.dw     $3DF9   ;TR_CHARPUT
.dw     $3DFF   ;CLEARLCD
.dw     $3E05   ;D_HL_DECI
.dw     $3E5F   ;CLEARTEXT
.dw     $3E6B   ;D_ZT_STR
.dw     $3EA7   ;BUSY_OFF
.dw     $3EBF   ;BUSY_ON
.dw     $6C9A   ;FIND_PIXEL
.dw     $2209   ;ZB_BYTES
.dw     $2652   ;MUL_HL
.dw	$29B3	;ALLOCATE
.dw	$2C5C	;DELETE_VAR
.dw     $2C46   ;REMOVE_DE
.dw     $2DF9   ;VPOP_A
.dw     $2DE8   ;VPUSH_A
.dw     $3C8B   ;GRAPH2LCD
.dw     $3DB1   ;D_MENU
.dw     $3D8D   ;SAVE_TEXT
.dw     $3BE9   ;SAVE_TEXM
.dw     $3DB7   ;CLR_WINDOW
.dw     $3DED   ;CLR_LINE
.dw     $3E71   ;C2TOP
.dw     $3EB3   ;KEY_HANDLER

Rom3A:
.dw     $3FEE   ;TX_CHARPUT
.dw     $3B9E   ;D_LT_STR
.dw     $3BDA   ;M_CHARPUT
.dw     $3BE0   ;D_ZM_STR
.dw     $3C22   ;D_LM_STR
.dw     $3CA0   ;GET_T_CUR
.dw     $3D90   ;SCROLL_UP
.dw     $3DF6   ;TR_CHARPUT
.dw     $3DFC   ;CLEARLCD
.dw     $3E02   ;D_HL_DECI
.dw     $3E5C   ;CLEARTEXT
.dw     $3E68   ;D_ZT_STR
.dw     $3EA4   ;BUSY_OFF
.dw     $3EBC   ;BUSY_ON
.dw     $6C9A   ;FIND_PIXEL
.dw     $2205   ;ZB_BYTES
.dw     $264E   ;MUL_HL
.dw	$29AF	;ALLOCATE
.dw	$2C58	;DELETE_VAR
.dw     $2C42   ;REMOVE_DE
.dw     $2DF5   ;VPOP_A
.dw     $2DE4   ;VPUSH_A
.dw     $3C88   ;GRAPH2LCD
.dw     $3DAE   ;D_MENU
.dw     $3D8A   ;SAVE_TEXT
.dw     $3BE6   ;SAVE_TEXM
.dw     $3DB4   ;CLR_WINDOW
.dw     $3DEA   ;CLR_LINE
.dw     $3E6E   ;C2TOP
.dw     $3EB0   ;KEY_HANDLER

RAddress:

.end

